=== modules/intensity_transform/CMakeLists.txt ===
set(the_description "Intensity transformations")
ocv_define_module(intensity_transform opencv_core opencv_imgproc WRAP python)
